#include <sourcemod>
#include <sdktools>
#include <sdkhooks>

#define NAME "DOD:S Throwing Knives"
#define VERSION "1.3"
#define KNIFE_MDL "models/weapons/allies_knife.mdl"
#define SPADE_MDL "models/weapons/axis_spade.mdl"
#define TRAIL_MDL "materials/sprites/lgtning.vmt"
#define TRAIL_COLOR {177, 177, 177, 117}
#define ADD_OUTPUT "OnUser1 !self:Kill::1.7:1"


new Handle:g_CVarEnable;
new Handle:g_hLethalArray;

new Handle:g_CVarVelocity;
new Float:g_fVelocity;

new Handle:g_CVarSpadesVelocity;
new Float:g_SpadesfVelocity;

new Handle:g_CVarKnives;
new Handle:g_CVarTrail;

new Handle:g_CVarSpades;
new Handle:g_CVarSpadesTrail;

new bool:g_bTrail;
new bool:g_bTrailSpades;

new g_iKnives[MAXPLAYERS+1];
new g_iSpades[MAXPLAYERS+1];

new const Float:g_fSpin[3] = {1877.4, 0.0, 0.0};

new g_iTrailMI;
new g_iTrailSpadesMI;

new Handle:dod_throwingknives_damage ;
new Handle:dod_throwingknives_radius ;
new Handle:dod_throwingknives_pushforce ;

new Handle:cv_amount;
new Handle:cv_flags;
new String:g_particle_file[] = "materials/particle/particledefault.vmt";
new String:g_particle[] = "UnlitGeneric\r\n{\r\n\"$translucent\" 1\r\n\"$basetexture\" \"Decals/blood_gunshot_decal\"\r\n\"$vertexcolor\" 1\r\n}\r\n";
new Handle:g_file_handle = INVALID_HANDLE;


public Plugin:myinfo = 
{

	name = NAME,
	author = "Andi67",
	version = VERSION,
	description = "Throwing knives/spades for Dods",
	url = "http://www.sourcemod.net"
};

public OnPluginStart()
{
	CreateConVar("dod_throwingknives", VERSION, NAME, FCVAR_PLUGIN|FCVAR_SPONLY|FCVAR_REPLICATED|FCVAR_NOTIFY|FCVAR_DONTRECORD);
	g_CVarEnable = CreateConVar("dod_throwingknives_enable", "1", "Enable/disable plugin.", _, true, 0.0, true, 1.0);

	g_CVarKnives = CreateConVar("dod_throwingknives_count", "10", "Amount of knives players spawn with.", _, true, 0.0, true, 100.0);
	g_CVarVelocity = CreateConVar("dod_throwingknives_velocity", "5", "Velocity (speed) adjustment.", _, true, 1.0, true, 10.0);
	g_CVarTrail = CreateConVar("dod_throwingknives_trail", "1", "Enable/disable trail effect.", _, true, 0.0, true, 1.0);
	
	g_CVarSpades = CreateConVar("dod_throwingspades_count", "10", "Amount of spades players spawn with.", _, true, 0.0, true, 100.0);
	g_CVarSpadesVelocity = CreateConVar("dod_throwingspades_velocity", "3", "Velocity (speed) adjustment.", _, true, 1.0, true, 10.0);
	g_CVarSpadesTrail = CreateConVar("dod_throwingspades_trail", "1", "Enable/disable trail effect.", _, true, 0.0, true, 1.0);
	
	dod_throwingknives_damage = 	CreateConVar("dod_throwingknives_damage", "50", "amount of damage", FCVAR_PLUGIN);
	dod_throwingknives_radius = CreateConVar("dod_throwingknives_radius", "200", " radius of start", FCVAR_PLUGIN);	
	dod_throwingknives_pushforce =  CreateConVar("dod_throwingknives_pushforce", "600", "pushforce that is done", FCVAR_PLUGIN);	

	g_bTrail = GetConVarBool(g_CVarTrail);
	HookConVarChange(g_CVarTrail, CVarChange);
	g_fVelocity = (1000.0 + (250.0 * GetConVarFloat(g_CVarVelocity)));
	HookConVarChange(g_CVarVelocity, CVarChange);
	g_SpadesfVelocity = (1000.0 + (250.0 * GetConVarFloat(g_CVarSpadesVelocity)));
	HookConVarChange(g_CVarSpadesVelocity, CVarChange);	
	g_bTrailSpades = GetConVarBool(g_CVarSpadesTrail);
	HookConVarChange(g_CVarSpadesTrail, CVarChange);	

	AutoExecConfig(true,"dod_throwingknives", "dod_throwingknives")

	g_hLethalArray = CreateArray();
	
	cv_amount = CreateConVar("sm_blood_level","1000","Amount of blood that is beeing spread",FCVAR_PLUGIN);
	cv_flags = CreateConVar("sm_blood_flags","15","A number that is a sum of the following values: 1 = Random direction, 2: Blood stream, 4: On Player, 8: Spray decals",FCVAR_PLUGIN);
	if (!FileExists(g_particle_file, true)) 
	{
		g_file_handle = OpenFile(g_particle_file,"a");
		if (g_file_handle != INVALID_HANDLE) 
		{
			WriteFileString(g_file_handle,g_particle,false);
			CloseHandle(g_file_handle);
		}
	}		

	HookEvent("player_spawn", EventPlayerSpawn);
	HookEvent("dod_stats_weapon_attack", EventDodStatsWeaponAttack);
}

public OnMapStart()
{
	g_iTrailMI = PrecacheModel(TRAIL_MDL);
	g_iTrailSpadesMI = PrecacheModel(TRAIL_MDL);	
	
	AddFileToDownloadsTable("models/weapons/axis_spade.dx80.vtx");
	AddFileToDownloadsTable("models/weapons/axis_spade.dx90.vtx");
	AddFileToDownloadsTable("models/weapons/axis_spade.mdl");
	AddFileToDownloadsTable("models/weapons/axis_spade.phy");
	AddFileToDownloadsTable("models/weapons/axis_spade.sw.vtx");
	AddFileToDownloadsTable("models/weapons/axis_spade.vvd");	
	
	AddFileToDownloadsTable("models/weapons/allies_knife.dx80.vtx");
	AddFileToDownloadsTable("models/weapons/allies_knife.dx90.vtx");
	AddFileToDownloadsTable("models/weapons/allies_knife.mdl");
	AddFileToDownloadsTable("models/weapons/allies_knife.phy");
	AddFileToDownloadsTable("models/weapons/allies_knife.sw.vtx");
	AddFileToDownloadsTable("models/weapons/allies_knife.vvd");
	PrecacheModel(KNIFE_MDL , true);
	PrecacheModel(SPADE_MDL , true);
}

public CVarChange(Handle:convar, const String:oldValue[], const String:newValue[]) 
{

	if ((convar == g_CVarEnable) && (StringToInt(newValue) == 1)) 
	{
		for (new i = 1; i <= MaxClients; i++)
			g_iKnives[i] = GetConVarInt(g_CVarKnives);
		for (new i = 1; i <= MaxClients; i++)
			g_iSpades[i] = GetConVarInt(g_CVarSpades);
	}
	else if (convar == g_CVarVelocity)
		g_fVelocity = (1000.0 + (250.0 * StringToFloat(newValue)));
	
	else if (convar == g_CVarSpadesVelocity)
		g_SpadesfVelocity = (1000.0 + (250.0 * StringToFloat(newValue)));
	
	else if (convar == g_CVarTrail)
		g_bTrail = GetConVarBool(g_CVarTrail);
	
	else if (convar == g_CVarSpadesTrail)
		g_bTrailSpades = GetConVarBool(g_CVarSpadesTrail);	
}

public EventPlayerSpawn(Handle:event,const String:name[],bool:dontBroadcast) 
{
	if (GetConVarBool(g_CVarEnable)) 
	{
		new client = GetClientOfUserId(GetEventInt(event, "userid"));
		g_iKnives[client] = GetConVarInt(g_CVarKnives);
		g_iSpades[client] = GetConVarInt(g_CVarSpades);
	}
}

public EventDodStatsWeaponAttack(Handle:event,const String:name[],bool:dontBroadcast)
{
	new weaponid = GetEventInt(event, "weapon");
	
	if (GetConVarBool(g_CVarEnable)) 
	{
		new client;
		client = GetClientOfUserId(GetEventInt(event, "attacker"));

		if(weaponid == 1 && (g_iKnives[client] > 0))
		{
			decl Float:fPos[3], Float:fAng[3], Float:fVel[3];
			GetClientEyePosition(client, fPos);

			new entity = CreateEntityByName("prop_physics");
			DispatchKeyValue(entity,"model", KNIFE_MDL);
			DispatchSpawn(entity); 
	
			SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
			SetVariantString(ADD_OUTPUT);
			AcceptEntityInput(entity, "AddOutput");

			GetClientEyeAngles(client, fAng);
			GetAngleVectors(fAng, fVel, NULL_VECTOR, NULL_VECTOR);
			ScaleVector(fVel, g_fVelocity);
			SetEntPropVector(entity, Prop_Data, "m_vecAngVelocity", g_fSpin);
			SetEntPropFloat(entity, Prop_Send, "m_flElasticity", 0.2);

			PushArrayCell(g_hLethalArray, entity);
			TeleportEntity(entity, fPos, fAng, fVel);
			--g_iKnives[client];
			PrintHintText(client, "Throwing Knives : %i", g_iKnives[client]);
			if (g_bTrail) 
			{
				TE_SetupBeamFollow(entity, g_iTrailMI, 0, 0.7, 7.7, 7.7, 3, TRAIL_COLOR);
				TE_SendToAll();
			}
			SDKHook(entity, SDKHook_StartTouch, OnStartTouch);
			CreateTimer(1.0, RemoveEntity, entity);			
		}
		
		
		if(weaponid == 2 && (g_iSpades[client] > 0))
		{
			decl Float:fPos[3], Float:fAng[3], Float:fVel[3];
			GetClientEyePosition(client, fPos);

			new entity = CreateEntityByName("prop_physics");
			DispatchKeyValue(entity,"model", SPADE_MDL);
			DispatchSpawn(entity); 
	
			SetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity", client);
			SetVariantString(ADD_OUTPUT);
			AcceptEntityInput(entity, "AddOutput");

			GetClientEyeAngles(client, fAng);
			GetAngleVectors(fAng, fVel, NULL_VECTOR, NULL_VECTOR);
			ScaleVector(fVel, g_SpadesfVelocity);
			SetEntPropVector(entity, Prop_Data, "m_vecAngVelocity", g_fSpin);
			SetEntPropFloat(entity, Prop_Send, "m_flElasticity", 0.2);

			PushArrayCell(g_hLethalArray, entity);
			TeleportEntity(entity, fPos, fAng, fVel);
			--g_iSpades[client];
			PrintHintText(client, "Throwing Spades : %i", g_iSpades[client]);
			if (g_bTrailSpades) 
			{
				TE_SetupBeamFollow(entity, g_iTrailSpadesMI, 0, 0.7, 7.7, 7.7, 3, TRAIL_COLOR);
				TE_SendToAll();
			}
			SDKHook(entity, SDKHook_StartTouch, OnStartTouch);
			CreateTimer(1.0, RemoveEntity, entity);
		}
	}
}

public OnStartTouch(entity, other) 
{
	new orbstate = GetEntProp(other, Prop_Data, "m_CollisionGroup");
	new attacker = GetEntPropEnt(entity, Prop_Send, "m_hOwnerEntity");
	if(orbstate == 5)
	{
		if(GetClientTeam(other) != GetClientTeam(attacker))
		{
			static Float:AttPos[3];
			GetClientAbsOrigin(other, AttPos);
		
			new Float:damage=GetConVarFloat(dod_throwingknives_damage);
			new Float:radius=GetConVarFloat(dod_throwingknives_radius);
			new Float:pushforce=GetConVarFloat(dod_throwingknives_pushforce);
		
			new pointHurt = CreateEntityByName("point_hurt");   
 	
			DispatchKeyValueFloat(pointHurt, "Damage", damage);        
			DispatchKeyValueFloat(pointHurt, "DamageRadius", radius);     
			DispatchKeyValue(pointHurt, "DamageDelay", "0.0");   
			DispatchSpawn(pointHurt);
			TeleportEntity(pointHurt, AttPos, NULL_VECTOR, NULL_VECTOR);  
			AcceptEntityInput(pointHurt, "Hurt", -1);    
			CreateTimer(0.1, DeletePointHurt, pointHurt); 
	
		
			new push = CreateEntityByName("point_push");         
			DispatchKeyValueFloat (push, "magnitude", pushforce);                     
			DispatchKeyValueFloat (push, "radius", radius*1.0);                     
			SetVariantString("spawnflags 24");                     
			AcceptEntityInput(push, "AddOutput");
			DispatchSpawn(push);   
			TeleportEntity(push, AttPos, NULL_VECTOR, NULL_VECTOR);  
			AcceptEntityInput(push, "Enable", -1, -1);
			CreateTimer(0.5, DeletePushForce, push);
				
	
			decl String:flags[3];
			decl String:amount[6];
			GetConVarString(cv_flags, flags, sizeof(flags));
			GetConVarString(cv_amount, amount, sizeof(amount));
			new ent = CreateEntityByName("env_blood");

			DispatchSpawn(ent);
			DispatchKeyValue(ent, "spawnflags", flags);
			DispatchKeyValue(ent, "amount", amount);
			DispatchKeyValue(ent, "color", "0");
			AcceptEntityInput(ent, "EmitBlood", other);
			CreateTimer(2.0, WipeBlood, ent);
		}
	}
}

public Action:RemoveEntity(Handle:timer, any:entity)
{
	 if (IsValidEntity(entity))
	 {
		 decl String:classname[64];
		 GetEdictClassname(entity, classname, sizeof(classname));
		 if (StrEqual(classname, "prop_physics", false))
			{
				RemoveEdict(entity);
			}
	 }
}

public Action:WipeBlood(Handle:timer, any:ent)
{
	if ((ent == -1) || (!IsValidEdict(ent)))
	{
		return Plugin_Continue;
	}
	RemoveEdict(ent);
	return Plugin_Handled;
}

public Action:DeletePushForce(Handle:timer, any:push)
{
	if (IsValidEntity(push))
	{
		decl String:classname[64];
		GetEdictClassname(push, classname, sizeof(classname));
		if (StrEqual(classname, "point_push", false))
		{
			RemoveEdict(push);
		}
	}
}
public Action:DeletePointHurt(Handle:timer, any:pointHurt)
{
	if (IsValidEntity(pointHurt))
	{
		decl String:classname[64];
		GetEdictClassname(pointHurt, classname, sizeof(classname));
		if (StrEqual(classname, "point_hurt", false))
		{
			RemoveEdict(pointHurt);
		}
	}
}